#include <Servo.h>
#include <Keypad.h>

/*
Control del servo desde el keypad
*/

int servoPin = 3;
Servo miServo;

//keypad
const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns

//matriz de mapeo del teclado
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

//conexión de filas y columnas del keypad al Arduino
byte rowPins[ROWS] = {13, 12, 11, 10}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {8, 7, 6, 5}; //connect to the column pinouts of the keypad

// creación del objeto teclado
Keypad teclado = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

int angulo, controlVelocidad;

void setup() {
  Serial.begin(9600);
  miServo.attach(servoPin);

  miServo.write(0);
  angulo = 0;
  

}

void loop() {
  /*
  Al presionar 1, movemos el servo a 90 grados
  Al presionar 0, movemos el servo a 0 grados
  Al presionar A, hacemos que el servo gire y regrese entre 0 y 180
  a una cierta velocidad
  */

  //leemos el teclado
  char tecla = teclado.getKey();

  if (tecla){
    Serial.println(tecla);
    if (tecla == '1'){
      miServo.write(90);

    }else if (tecla == '0'){
      miServo.write(0);

    }else if (tecla == 'A'){
      controlVelocidad = 50;
      angulo = 0;
      for (int i=angulo; i<=180; i++){
        miServo.write(i);
        delay(controlVelocidad);
      }
      delay(1000);
      angulo = 180;
      for (int i=angulo; i>=0; i--){
        miServo.write(i);
        delay(controlVelocidad);
      }
    }
  }

}
